import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.URL;
import java.net.URLEncoder;

public class FalseYahoo extends HttpServlet {
    final int maxQueries = 10;
    final String favoriteSite = "www.di.uniroma1.it";

    private String getLastQueries(HttpSession session, int maxQ) {
	String res = "";
	int maxC = (Integer)session.getAttribute("how_many");
	for (int i = maxC - maxQ; i <= maxC; i++) {
	    res += session.getAttribute(Integer.toString(i)) + "||";
	}
	// Enumeration attributes = session.getAttributeNames();
	// while (attributes.hasMoreElements()) {
	//     String param = (String)attributes.nextElement();
	//     if (Integer.parseInt(param) > maxC - maxQ)
	// 	res += session.getAttribute(param) + "||";
	// }
	return res;
    }
    
    protected void doGet( HttpServletRequest request,
			  HttpServletResponse response )
	throws ServletException, IOException
    {
	response.setContentType( "text/html" );
	PrintWriter out = response.getWriter();
	String query = request.getParameter( "query" );
	if ( query == null ) {
	    out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n" +
			"    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	    out.println("<html xmlns = \"http://www.w3.org/1999/xhtml \">");
	    out.println("<head><title>Cerca con Google</title></head><body><form method = \"post\" action = \"yahoo\"><table width=\"100%\"><tr align = \"center\"><td height = \"300px\" align = \"center\" valign = \"center\"><input type = \"text\" name = \"query\"/><input type = \"submit\" value = \"Cerca\" name = \"query\"/></td></tr></table></form></body></html>");
	    return;
	}
	HttpSession session = request.getSession(true);
	session.setAttribute("how_many", session.isNew()? 1 : (Integer)session.getAttribute("how_many") + 1);
	session.setAttribute(Integer.toString((Integer)session.getAttribute("how_many")), query);
	String queries = URLEncoder.encode(getLastQueries(session, maxQueries), "UTF-8");
	try {
	    BufferedReader reader = new BufferedReader(new InputStreamReader(new URL("http://it.search.yahoo.com/search?p=" + URLEncoder.encode(request.getParameter("query"), "UTF-8")).openStream(), "UTF-8"));
	    String line, all_lines = "";
	    while ((line = reader.readLine()) != null)
		all_lines += line;
	    all_lines = all_lines.replace(favoriteSite, favoriteSite + "?queries=" + queries);
	    out.print(all_lines);
	}
	catch (Exception e) {
	    out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n" +
			"    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	    out.println("<html xmlns = \"http://www.w3.org/1999/xhtml \">");
	    out.println( "<head>" );
	    out.println( "<title>Risultato della ricerca</title>" );
	    out.println( "</head>" );
	    out.println( "<body>" );
	    System.out.println("Servlet FalseYahoo: Errore nell'inviare la richiesta a Yahoo: " + e.getMessage());
	    e.printStackTrace(); //sempre sul log!
	    out.println("<p><b>Impossibile effettuare la ricerca</b></p>");
	    out.println("</body></html>");
	    return;
	}
	out.close(); // close stream to complete the page
    }

    protected void doPost( HttpServletRequest request,
			  HttpServletResponse response )
	throws ServletException, IOException
    {
	doGet(request, response);
    }
}
