import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class Login extends HttpServlet {

    private String logins = "admin:admin_user1:user1_user2:user2";
    private String nome_pagina_protetta1 = "/teledidattica_web_appl_4/pagina_protetta.html";
    private String nome_pagina_protetta2 = "/teledidattica_web_appl_4/pagina_protetta2.html";
    private String pagina_login = "/teledidattica_web_appl_4/login.html";
    private String pagina_logout = "/teledidattica_web_appl_4/login.html?logout";
    
    protected void doPost( HttpServletRequest request,
			  HttpServletResponse response )
	throws ServletException, IOException
    {
	response.setContentType( "text/html" );
	PrintWriter out = response.getWriter();
	String logout = request.getParameter( "logout" );
	if (logout != null) {
	    HttpSession session = request.getSession(true);
	    session.invalidate();
	    out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n" +
			"    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	    out.println("<html xmlns = \"http://www.w3.org/1999/xhtml \">");
	    out.println( "<head>" );
	    out.println( "<title>Sessione invalidata</title>" );
	    out.println( "</head><body><p><b>Sessione invalidata</b></p>" );
	    out.println("</body></html>");
	    return;
	}
	String username = request.getParameter( "username" );
	if ( username != null ) {
	    String[] allUsers = logins.split("_");
	    HttpSession session = request.getSession(true);
	    session.removeAttribute("username");
	    for (int i = 0; i < allUsers.length; i++) {
		if (allUsers[i].equals(username + ":" + request.getParameter("password"))) {
		    session.setAttribute("username", username);
		    break;
		}
	    }
	}
	HttpSession session = request.getSession(true);
	username = (String)session.getAttribute( "username" );
	if (username == null) {
	    out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n" +
			"    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	    out.println("<html xmlns = \"http://www.w3.org/1999/xhtml \">");
	    out.println( "<head>" );
	    out.println( "<title>&Egrave; necessario loggarsi!</title>" );
	    out.println( "</head><body>" );
	    if (request.getParameter("username") != null)
		out.println("<p><b>Lo username " + request.getParameter("username") + " non &egrave; abilitato, o la password &egrave; sbagliata</b></p>");
	    out.println( "<form method = \"post\" action = \"" + pagina_login + "\"><label>Username: <input type = \"text\" name = \"username\"/></label><br/><label>Password: <input type = \"password\" name = \"password\"/></label><input type = \"submit\" value = \"Log In\"/></form>" );
	    out.println("</body></html>");
	}
	else {
	    out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n" +
			"    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
	    out.println("<html xmlns = \"http://www.w3.org/1999/xhtml \">");
	    out.println( "<head>" );
	    out.println( "<title>Benvenuto " + username + "!</title>" );
	    out.println( "</head>" );
	    out.println( "<body><p><b>Benvenuto " + username + "!</b></p>" );
	    out.println("<p>Vai all'altra <a href=\"" + (request.getRequestURI().equals(nome_pagina_protetta1)? nome_pagina_protetta2 : nome_pagina_protetta1) + "\">pagina protetta</a></p>");
	    out.println("<p>Oppure fai <a href=\"" + pagina_logout + "\">logout</a></p>");
	    out.println("</body></html>");
	}
	out.close(); // close stream to complete the page
    }
    
    protected void doGet( HttpServletRequest request,
			  HttpServletResponse response )
	throws ServletException, IOException
    {
	doPost(request, response);
    }
}
